;%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

#include "TM57ML40_en.inc" 
#include	"maico.asm"
	
		org		000h	  
		goto	start 
		nop
		org		03h 
        goto	time0_int

		org		08h
		goto	rfc_int
;-----------------------------------
		org		10h	 
start: 								;pwm Initialization  
 		call	sysinit    


		movlw	1
		movwf	led_ram00 
		movwf	led_ram01 
		movwf	led_ram02 
		movwf	led_ram03 
		
;-----------------------------------	
;		    ѭ
;-----------------------------------	
main:

		btfss	f_4ms
		goto	main_end
		bcf		f_4ms
 		
main_end:
		goto	main	
;********************************************************
;4ֽڳ4ֽ      ()/()=()  ()
;input	:temp_reg3 temp_reg2 temp_reg1 temp_reg0	() 
;input	:temp_reg7 temp_reg6 temp_reg5 temp_reg4	()
;output	:temp_reg11 temp_reg10 temp_reg9 temp_reg8	()
;output	:temp_reg3 temp_reg2 temp_reg1 temp_reg0	()
;******************************************************** 		
timer_250ms:
        decfsz  timer250,1
        goto    timer_250ms_end 
        movlw   timer250_setup
        movwf   timer250
        
        btfsc	f_rfc_error
        goto	error
        
        cja_idata	rfc_count2_h,0,te_odd
        cja_idata	rfc_count2_l,4,te_odd
 
error: 
		bcf		f_rfc_error       
		movlw	10
		movwf	led_ram00 	
		movwf	led_ram01 
		movwf	led_ram02
		movwf	led_ram03 
		goto    timer_250ms_end
		
;********************************** 
;	4000/׼ŵ=һʱ
;********************************** 
te_odd:
;	    call	clr_math      
;       movlw	0x6
;       movwf	temp_reg2 
;       movlw	0x1a
;       movwf	temp_reg1
;       movlw	0x80
;       movwf	temp_reg0		;() 400000  =ʾֵX1000 
;
;       movlw	0x0                     
;       movwf	temp_reg2                
;       movlw	0x9c                    
;       movwf	temp_reg1                
;       movlw	0x40                    
;       movwf	temp_reg0		;() 40000    =ʵX100 
        
        movlw	0x0                     
        movwf	temp_reg2                
        movlw	0x0F                  
        movwf	temp_reg1                
        movlw	0xA0                    
        movwf	temp_reg0		;() 4000      =ʾֵX10 


		movlw	0
        movwf	temp_reg7 
        movwf	temp_reg6 
        movfw	rfc_count_h	
        movwf	temp_reg5
        movfw	rfc_count_l	
        movwf	temp_reg4		;
        
        call	div4byted4byte
        
        movfw	temp_reg1 
        movwf	B_TEMP_RFC_H
        movfw	temp_reg0
        movwf	B_TEMP_RFC_L      ;
;********************************** 
;	4000/ŵ=һʱ
;********************************** 
		call	clr_math      
        movlw	0x6
        movwf	temp_reg2 
        movlw	0x1a
        movwf	temp_reg1
        movlw	0x80
        movwf	temp_reg0		;()

		movlw	0
        movwf	temp_reg6 
        movwf	temp_reg7 
        movfw	rfc_count2_h	
        movwf	temp_reg5
        movfw	rfc_count2_l
        movwf	temp_reg4		; 
        
        call	div4byted4byte
        
        movfw	temp_reg1 
        movwf	T_TEMP_RFC_H
        movfw	temp_reg0
        movwf	T_TEMP_RFC_L    
;********************************** 
;	 һʱ *10(׼ֵ)
;**********************************  
;**********************************
;ֽڳһֽ
;input	:temp_reg6 temp_reg5 temp_reg4 * temp_reg7
;output	:temp_reg3 temp_reg2 temp_reg1 temp_reg0
		call	clr_math  
		movfw	T_TEMP_RFC_L  
		movwf	temp_reg4
		movfw	T_TEMP_RFC_H   
		movwf	temp_reg5
		
		movlw	10
		movwf	temp_reg7
		call	mul3_1byte
		
		movfw	temp_reg0
		movwf	T_TEMP_RFC_L 
		movfw	temp_reg1
		movwf	T_TEMP_RFC_H 
;********************************************************
;4ֽڳ4ֽ      ()/()=()  ()
;input	:temp_reg3 temp_reg2 temp_reg1 temp_reg0	() 
;input	:temp_reg7 temp_reg6 temp_reg5 temp_reg4	()
;output	:temp_reg11 temp_reg10 temp_reg9 temp_reg8	()
;output	:temp_reg3 temp_reg2 temp_reg1 temp_reg0	()
;******************************************************** 
;********************************** 
;	
;**********************************	
		call	clr_math
		movfw	T_TEMP_RFC_L 
		movwf	temp_reg0
		movfw	T_TEMP_RFC_H
		movwf	temp_reg1
		
		
		movfw	B_TEMP_RFC_L
		movwf	temp_reg4		
		movfw	B_TEMP_RFC_H
		movwf	temp_reg5 

        call	div4byted4byte 
         
    
 		mov_m	led_ram00,temp_reg0
 		mov_m	led_ram01,temp_reg1
 		call	clr_math	
 
 		mov_m	temp_reg5,led_ram00
 		mov_m	temp_reg6,led_ram01
		call	adjust_ten
		
		movfw	temp_reg3
		movwf	led_ram00 	
		movfw	temp_reg2
		movwf	led_ram01 
		movfw	temp_reg1
		movwf	led_ram02
		movfw	temp_reg0 
		movwf	led_ram03 
		
timer_250ms_end:
		ret
           
;----------------------------------- 
;		LCD off and  all light
;----------------------------------- 
off_lcd:
		movlw	11111111b 
		goto	lcd_ram	
light_lcd:
 		movlw	00000000b 
lcd_ram:
        movwr	DS_LCD1
        movwr	DS_LCD2
        movwr	DS_LCD3
        movwr	DS_LCD4
        movwr	DS_LCD5
        movwr	DS_LCD6
        movwr	DS_LCD7
        movwr	DS_LCD8
        ret 
;----------------------------------- 
;			ϵͳʼ
;-----------------------------------   
sysinit:
		bcf		STAT,5			;=0ѡ RAM bank0 =1ѡ RAM bank1 
		movlw	0x20
		movwf	FSR	
clr_bank00:		
		movlw	0x00
		movwf	INDF
		incf	FSR,1
		movfw	FSR
		xorlw	0x7f
		btfss	STAT,2
		goto	clr_bank00
		movlw	0x00
		movwf	INDF  
;---------------------------------
		bsf		STAT,5
		movlw	0x20
		movwf	FSR
clr_bank1:	
		movlw	0x00
		movwf	INDF
		incf	FSR,1
		movfw	FSR
		xorlw	0x7f
		btfss	STAT,2
		goto	clr_bank1
		movlw	0x00
		movwf	INDF
		
;-----------------------------------		
led_set:
        movlw	00001110b
		movwr	LCD_LED 			;bit3 1:LED display on 0: LED display off
									;bit2 1:LED high active 0: low active
									;bit1 0:Select LCD 1: Select LED
									;bit0 1:LCD Enable 0: Disable
		
		bsf		flag_one,f_san_00	;ɨһLCD

		movlw	00011110b
		movwr	TM2CTRL
		
        movlw	11011111b
		movwr	LCDCTRL             	
									;bit(5~3) LCD/LED Duty
									;000: Static
									;001: 1/2 duty
									;010: 1/3 duty
									;011: 1/4 duty
									;100: 1/5 duty
									;101: 1/6 duty
									;110: 1/7 duty
									;111: 1/8 duty
;------------------------------		
		movlw   00000000B
		movwf 	INTF1
		
		movlw   00000000B
		movwf	INTE1
		
		movlw   00100000b
		movwr	CLKCTRL	 			;Auto Save W register and STATUS register when interrupt, 

		movlw	11111111b
		movwr	PAE	              	;is output

		movlw	11111111b
		movwr	PBD	              	
		movlw	11100011b
		movwr	PBE	              	;is input
		movlw	11111111b
		movwr	NPBPU
		
		movlw	131
		movwf	TIMER0				;Timer 0 data 
		movlw	131
		movwr	TM0RELOAD			;Time0 Reload Data
		movlw	00000110b
		movwr	OPTION              ;bit0-3ʱƵ
		
        bsf		INTE1,TM0IE			;򿪶ʱ0
       	
		movlw	01010001b
		movwr	RFCCON				;bit6 Timer0 overflow to control RFC
									;bit4 select CX0 as RFC Counter CLK
									;bit0 select RFC0 pin for RFC loop
		
		bsf		INTE2,RFCINTE  		;RFC Interrupt Enable.
		bcf		TM_CTRL,CLRRFC		;RFC 
		bcf		TM_CTRL,RFCSTOP 	;start RFC Counter/Loop 
		

        movlw   timer250_setup
        movwf   timer250
  		movlw	delay_rt_setup	
        movwf	delay_rt		

sysinit_end:
		ret     	
;----------------------------------- 
;	  ʱ0 ΪRFC
;-----------------------------------              
time0_int:
		movlw	11101111b
		movwf	INTF1
  		bsf		f_4ms
 		call    off_lcd
 		call	led_scan	
 		
;		btfss	PAD,0  				;timer0 ouput teset
;		goto	saver_rfc
;		
;		bcf		PAD,0 
;		goto	ts_rf	
;saver_rfc:		 
;		bsf		PAD,0				
;ts_rf:		
		btfss	f_rt_change			;жǲο軹Ǳ
		goto	scond_ts
		
		decfsz	delay_rt,1
		goto    time0_int_end
		movlw	delay_rt_setup	
        movwf	delay_rt	
        bcf		f_rt_change	
        	
		movfw	RFCNTH	
		movwf	rfc_count_h	
		movfw	RFCNTL
		movwf	rfc_count_l	
		movlw	01010010b       	;bit6 Timer0 overflow to control RFC	
		movwr	RFCCON	
		bsf		TM_CTRL,CLRRFC
		bcf		TM_CTRL,CLRRFC
		call	timer_250ms
		goto	time0_int_end
scond_ts:
		decfsz	delay_rt,1
		goto    time0_int_end
		movlw	delay_rt_setup	
        movwf	delay_rt
		bsf		f_rt_change
		
		movfw	RFCNTH	
		movwf	rfc_count2_h
		
		movfw	RFCNTL
		movwf	rfc_count2_l	
		
		movlw	01010001b
		movwr	RFCCON				;bit6 Timer0 overflow to control RFC		
	    bsf		TM_CTRL,CLRRFC
		bcf		TM_CTRL,CLRRFC
time0_int_end:	

		reti
;----------------------------------- 		
rfc_int:  
		bcf		INTF2,RFCINTF  
		bsf		f_rfc_error  		;set error flag

		goto	int_end
	
int_end:
		reti
;-----------------------------------
;		 Ĵ
;-----------------------------------
clr_math:
		clrf	temp_reg0			
		clrf	temp_reg1			
		clrf	temp_reg2			
		clrf	temp_reg3			
		clrf	temp_reg4			
		clrf	temp_reg5			
		clrf	temp_reg6			
		clrf	temp_reg7			
		clrf	temp_reg8			
		clrf	temp_reg9			
		clrf	temp_reg10			
		clrf	temp_reg11			
		clrf	temp_reg12	
clr_math_end:
		ret			
;----------------------------------- 
;			ļ
;-----------------------------------        	
#include	scan_led.asm
#include    math.asm 

       	
     	end